<template>
    <div class="context">
        <div class="panel">
            <h5>课程表模板</h5>
        </div>
        <div class="change">
            <el-button type="primary" @click="addLessonTable">新增课程表模板</el-button>
            <el-button type="" @click="copyDialog">复制</el-button>
            <el-button type="" @click="delList">删除</el-button>
        </div>
        <div class="table">
            <el-table
                    :data="tableData"
                    border
                    is-horizontal-resize
                    :default-sort="{prop: 'date', order: 'descending'}"
                    element-loading-background="rgba(0, 0, 0, 0.8)"
                    class=""
                    @selection-change="handleSelectionChange"
            >
                <el-table-column
                        type="selection"
                        width="55">
                </el-table-column>
                <el-table-column
                        type="index"
                        label="序号"
                        width="50">
                </el-table-column>
                <el-table-column
                        prop="PlanName"
                        label="课程表模板名称"
                >
                    <template slot-scope="scope">
                        <span class="link" @click="goEdit(scope.row)">
                               {{scope.row.PlanName}}
                        </span>

                    </template>
                </el-table-column>
                <el-table-column
                        prop="CreateColumn.CreatedAt"
                        label="最后编辑时间"
                        :formatter="filterFmtDate"
                        sortable
                >
                </el-table-column>
                <el-table-column
                        prop="ShopId"
                        label="是否通用"
                >
                    <template slot-scope="scope">
                        <el-switch
                                v-model="scope.row.ShopId"
                                :active-value="1"
                                :inactive-value="0"
                                active-color="#409EFF"
                                inactive-color="#D9D9D9"
                                @change=changeShopId($event,scope.row)
                        >
                        </el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                        prop="Status"
                        label="状态"
                        width="110"
                        align="center"
                        sortable
                >
                    <template slot-scope="scope">
                        <span v-if="scope.row.Status == 2">已发布</span>
                        <span v-if="scope.row.Status == 1">未发布</span>
                    </template>
                </el-table-column>
                <el-table-column
                        prop="Status"
                        label="操作"
                >
                    <template slot-scope="scope">
                        <el-button type="text" @click="goEdit(scope.row)">编辑</el-button>
                        <el-button type="text" @click="goEdit(scope.row)">预览本周</el-button>
                        <el-button type="success" size="mini" @click="openLessonTable(scope.row)">发布
                        </el-button>
                    </template>
                </el-table-column>

            </el-table>
            <br>
            <el-pagination
                    background
                    :total="pageination.total"
                    :page-size="pageination.pageItem"
                    @current-change="pageChange"
            ></el-pagination>
        </div>

        <el-dialog title="课程表模板复制" :visible.sync="dialogCopyVisible" width="640px">
            <el-form ref="form" :model="copyForm" label-width="160px">
                <el-form-item label="新模板名称">
                    <el-input v-model="copyForm.name" placeholder="请输入新模板名称"></el-input>

                </el-form-item>
            </el-form>
            <div class="dialogFooter">
                <el-button type="primary" size="small" @click="copy">确定</el-button>
                <el-button @click="dialogCopyVisible = false" size="small">取消</el-button>
            </div>
        </el-dialog>

        <el-dialog title="发布课程表" :visible.sync="dialogVisible" width="640px">
            <div class="dialogTitle">
                <span>{{form.name}}</span>
            </div>
            <div>
                <span class="demonstration">选择发布日期(按周选取)</span>
                <br>
                <br>
                <el-date-picker
                        v-model="form.week"
                        type="week"
                        :picker-options="{'firstDayOfWeek': 1}"
                        format="yyyy 第 WW 周"
                        placeholder="选择周"
                >
                </el-date-picker>
                <br>
                <br>
                <span>
                    微信可预约
                </span>
                <el-switch
                        v-model="form.appoint"
                        :active-value="1"
                        :inactive-value="0"
                        active-color="#409EFF"
                        inactive-color="#D9D9D9">
                </el-switch>
            </div>
            <div class="dialogFooter">
                <el-button type="primary" size="small" @click="public">确定</el-button>
                <el-button @click="dialogVisible = false" size="small">取消</el-button>
            </div>
        </el-dialog>
        <el-dialog title="预览本周" :visible.sync="previewVisible" width="1200px">
            <preview></preview>
            <div class="dialogFooter">
                <el-button @click="previewVisible = false" size="small">关闭</el-button>
            </div>
        </el-dialog>

    </div>
</template>

<script>
    import Global from '../Global.js'
    import preview from '@/components/preview.vue'
    import {
        SttPlanBasicListQuery,
        ClassVisibleStatusEdit,
        SttPlanBasicShopEdit,
        SttPlanBasicStatusEdit,
        SttPlanCopy,
        SttPlanPublish,
        testTable,
        testSelect,
    } from "../api/getApiRes";

    let qs = require('qs');
    export default {
        data() {
            return {
                dialogVisible: false,
                dialogCopyVisible: false,
                previewVisible: false,//todo
                dialogdata: [],
                dialogValue: [],
                // panel 配置项目
                multipleSelection: [],
                pageination: {
                    pageItem: 100,
                    pageoptions: pageOptions(),
                    total: 100,
                    pageIndex: 1,
                },
                form: {
                    Id: '',
                    name: '',
                    week: '',
                    wechat: 1,
                    appoint: 1,
                },
                copyForm: {
                    Id: '',
                    name: '',
                },
                tableData: []
            }
        },
        mounted() {
            this.getTableQuery();
        },
        methods: {
            // 通用修改
            changeShopId(e, row) {
                console.log(e);
                let that = this;
                let shopId = e == 1 ? localStorage.shopId : 0;
                let param = {
                    token: localStorage.token,
                    planId: row.PlanId,//
                    shopId: shopId,//0：跨店课程，通用 >0： 本店特有课程，不通用
                };
                let postdata = qs.stringify(param);
                SttPlanBasicShopEdit(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.$message({
                            showClose: true,
                            message: '当前课程表模板已' + json.Memo,
                            type: 'success'
                        });
                        // 重载列表
                        that.getTableQuery();
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            addLessonTable() {
                this.$router.push({
                    path: '/editLessonTable', query: {
                        id: 0,
                    }
                });
            },
            // 删除
            delList() {
                let that = this;
                // checkNum
                if (!this.multipleSelection.length) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }

                let row = that.multipleSelection[0];

                let param = {
                    token: localStorage.token,
                    planId: row.PlanId,
                    status: 9,//9删除
                };
                let postdata = qs.stringify(param);

                this.$confirm('此操作将永久删除该课程表模板, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    SttPlanBasicStatusEdit(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: '选中的课程表模板已删除！',
                                type: 'success'
                            });
                            // 重载列表
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo);
                        }
                    });
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消删除'
                    });
                });
            },
            copyDialog() {
                let that = this;
                if (!this.multipleSelection.length) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }
                let row = that.multipleSelection[0];
                this.copyForm.name = '';
                this.copyForm.Id = row.PlanId;
                this.dialogCopyVisible = true;
            },
            copy() {
                let that = this;
                // checkNum
                if (!that.copyForm.name) {
                    this.$message.error('错了哦，新模版名不能为空');
                    return false
                }
                if (that.copyForm.name.length > 20) {
                    this.$message.error('错了哦，新模版名字的字数超过20个字');
                    return false
                }

                let param = {
                    token: localStorage.token,
                    planId: that.copyForm.Id,
                    planName: that.copyForm.name,
                };
                let postdata = qs.stringify(param);

                this.$confirm('此操作将复制相同内容的课程表, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    SttPlanCopy(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: '选中的课程表已复制！',
                                type: 'success'
                            });
                            // 关闭弹窗
                            that.dialogCopyVisible = false;
                            // 重载列表
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo);
                        }
                    });
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消复制'
                    });
                });
            },
            // 发布课程表
            openLessonTable(row) {
                this.dialogVisible = true;
                this.form.name = row.PlanName;
                this.form.Id = row.PlanId;
                this.form.week = '';
            },
            // 发布
            public() {
                let that = this;
                if (!this.form.week) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，发布周期不能空',
                        type: 'error'
                    });
                    return false
                }

                let param = {
                    token: localStorage.token,
                    planId: this.form.Id,
                    incomingDate: nonTfmtDatetoLength(this.form.week, 10),//对应日期 字符串 年-月-日 格式
                    wxOrder: this.form.appoint,
                };
                let postdata = qs.stringify(param);
                SttPlanPublish(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.$message({
                            showClose: true,
                            message: this.form.name + '已发布！',
                            type: 'success'
                        });
                        // 重载列表
                        that.getTableQuery();
                        this.dialogVisible = false;
                    } else {
                        that.$message.error(json.Memo);
                    }
                });
            },
            // 取消发布
            unpubilc(row) {
                let that = this;
                let param = {
                    token: localStorage.token,
                    detectorid: row.Id,
                    status: 4,//0禁用1启用9删除
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.$message({
                            showClose: true,
                            message: '选中的课程表模板已取消发布！',
                            type: 'success'
                        });
                        // 重载列表
                        that.getTableQuery();
                    } else {
                        that.$message.error(json.Memo);
                    }
                });
            },
            // 编辑课程表模板
            goEdit(row) {
                this.$router.push({
                    path: '/editLessonTable', query: {
                        id: row.PlanId,
                        name: row.PlanName
                    }
                });
            },
            handleSelectionChange(val) {
                this.multipleSelection = val;
            },
            // 页面数据查询
            getTableQuery() {
                let that = this;
                that.loading = true;
                let param = {
                    token: localStorage.token,
                };
                let postdata = qs.stringify(param);
                SttPlanBasicListQuery(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.loading = false;
                        if (json.Rs) {
                            that.allTableData = json.Rs;
                            that.recordsTotal = json.Rs.length;
                        } else {
                            that.allTableData = [];
                            that.recordsTotal = 0;
                        }

                        // 设置分页数据
                        that.setPaginations();
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 设置分页数据
            setPaginations() {
                // 分页属性
                let that = this;
                that.pageination.total = that.recordsTotal;
                // 默认分页
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
            },
            // 每页显示数量
            handleSizeChange() {
                let that = this;
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
                that.draw = that.pageination.pageItem;
                that.getTableQuery();
            },
            // 翻页
            pageChange(pageIndex) {
                let that = this;
                // 获取当前页
                let index = that.pageination.pageItem * (pageIndex - 1);
                // 数据总数
                let nums = that.pageination.pageItem * pageIndex;
                // 容器
                let tables = [];
                for (var i = index; i < nums; i++) {
                    if (that.allTableData[i]) {
                        tables.push(that.allTableData[i])
                    }
                    this.tableData = tables;
                }
                that.start = index * that.draw;
                that.getTableQuery();
            },
            // 过滤时间
            filterFmtDate(value, row, column) {
                let that = this;
                return nonTfmtDate(column, 11);
            },
        },
        watch: {
            $route(to) {
                if (to.name == 'lessonTable') {
                    this.getTableQuery()
                }
            },
        },
        components: {
            preview
        }
    }
</script>

<style scoped>
    @import "../assets/css/panel.css";

    .context {
        height: 770px;

        overflow-y: scroll;

        display: block;
        margin: 0 auto;
        background-color: #fff !important;
        padding: 30px;
    }

    .panel-body {
        padding: 20px;
        background: #F0F2F5;
    }

    .change {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        padding-top: 10px;
        padding-bottom: 10px;
    }

    .change button {
        float: left;
    }

    .change button.pull-right {
        float: right;
    }

    .dialogTitle {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        color: #000000;
        font-size: 18px;
        text-align: center;
    }

    .dialogTitle span {
        width: 169px;
        height: 40px;
        line-height: 40px;
        text-align: center;
        color: #fff;
        background: #3799FF;
        border-radius: 250px;
        font-size: 14px;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        margin-bottom: 30px;
    }

    .dialogTitle em {
        float: none;
        font-style: normal;
        color: #3799FF;
        margin: 0;
    }

    /deep/ .el-transfer-panel__item .el-checkbox__input {
        left: 40px;
    }

    .dialogFooter {
        width: 90%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        margin-top: 10px;
    }

    .dialogFooter button {
        float: right;
        margin-left: 10px;
    }

    .link {
        color: #03B1FF;
        text-decoration: underline;
        cursor: pointer;
    }

    em {
        font-style: normal;
    }
</style>
